using System;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;
using UnityEngine.Serialization;

namespace CheesyFX
{
    public class CapsulePenetrator : Penetrator
    {
        private CapsuleCollider capsule;

        public CapsulePenetrator Init(CapsuleCollider capsule)
        {
            base.Init(capsule);
            this.capsule = capsule;
            SetTipAndWith();
            if (atom.type == "Dildo") RegisterDildo();
            if (capsule.name == "AutoColliderGen3bHard") RegisterPenis();
            return this;
        }
        
        private void RegisterPenis()
        {
            type = 1;
            root = atom.rigidbodies.First(x => x.name == "Gen1");
            rootTransform = atom.rigidbodies.First(x => x.name == "Gen1").transform;
            colliders = rootTransform.GetComponentsInChildren<Collider>().ToList();
            colliders.ForEach(x => FillMeUp.penetratorByCollider[x] = this);
            forward = () => capsule.transform.right;
            
        }

        private void RegisterDildo()
        {
            type = 2;
            root = atom.rigidbodies.First(x => x.name == "b1");
            rootTransform = root.transform;
            colliders = rootTransform.GetComponentsInChildren<Collider>().ToList();
            colliders.ForEach(x => FillMeUp.penetratorByCollider[x] = this);
            forward = () => capsule.transform.up;
        }

        public void SetTipAndWith()
        {
            scale = scaleChangeReceiver.scale;
            switch (capsule.direction)
            {
                case 0:
                    tip.localPosition = new Vector3(0f,capsule.radius * scale,0f);
                    width = capsule.height * scale*9f;
                    break;
                case 1:
                    tip.localPosition = new Vector3(0f,capsule.height * .5f * scale,0f);
                    width = 2f * capsule.radius * scale*9f;
                    break;
                case 2:
                    tip.localPosition = new Vector3(capsule.radius * scale, 0f, 0f);
                    width = capsule.height * scale*9f;
                    break;
            }
            // $"{atom.name} {capsule.name} {width} {capsule.direction}".Print();
        }

        private void OnEnable()
        {
            SetTipAndWith();
            foreach (var orifice in FillMeUp.orifices)
            {
                if (orifice.penetrator == this) orifice.penetratorWidth = width;
            }
        }
    }
}