using System.Collections;
using System.Linq;
using SimpleJSON;
using UnityEngine;
using Random = UnityEngine.Random;

namespace CheesyFX
{
    public class Hand : Fuckable
    {
        private float sideId;
        private Rigidbody handRB;
        public Hand other;
        public new CapsulePenetrator penetrator;
        private float widthToBendScale = 1f;
        public GameObject triggerGO;
        private GameObject depthReference;
        private float strokeDirection;

        // private JSONStorableFloat graspMultiplier = new JSONStorableFloat("Grasp Multiplier", 1f, 0f, 2f);

        private float lastDepth;
        private LerpingMorph[] thumbMorphs;
        private LerpingMorph[] indexMorphs;
        private LerpingMorph[] midMorphs;
        private LerpingMorph[] ringMorphs;
        private LerpingMorph[] pinkyMorphs;
        private Transform[] thumb;
        private Transform[] index;
        private Transform[] mid;
        private Transform[] ring;
        private Transform[] pinky;
        private LerpingMorph thumbOut;
        private float[] thumbAngles = new float[3];

        private float speedIncrement;

        private IEnumerator zeroSpeed;
        private IEnumerator zeroDepth;
        private IEnumerator zeroForce;

        private Vector3 snapForce;
        public Force radialForce;

        public new Hand Init(string side)
        {
            sideId = side == "l" ? -1f : 1f;
            base.Init(side + "Hand");
            CreateTriggersUI();
            ClearUI();
            enabled = false;
            // depthTriggers = FillMeUp.singleton.AddFloatTriggerManager(depth, false, 0f, 0f, .25f);
            // speedTriggers = FillMeUp.singleton.AddFloatTriggerManager(speed, true, 0f, 0f, .5f);
            handRB = FillMeUp.atom.rigidbodies.FirstOrDefault(x => x.name == $"{side}Hand");
            thumb = FillMeUp.atom.GetComponentsInChildren<DAZBone>().First(x => x.name == $"{side}Thumb1")
                .GetComponentsInChildren<DAZBone>().Select(x => x.transform).ToArray();
            index = FillMeUp.atom.GetComponentsInChildren<DAZBone>().First(x => x.name == $"{side}Index1")
                .GetComponentsInChildren<DAZBone>().Select(x => x.transform).ToArray();
            mid = FillMeUp.atom.GetComponentsInChildren<DAZBone>().First(x => x.name == $"{side}Mid1")
                .GetComponentsInChildren<DAZBone>().Select(x => x.transform).ToArray();
            ring = FillMeUp.atom.GetComponentsInChildren<DAZBone>().First(x => x.name == $"{side}Ring1")
                .GetComponentsInChildren<DAZBone>().Select(x => x.transform).ToArray();
            pinky = FillMeUp.atom.GetComponentsInChildren<DAZBone>().First(x => x.name == $"{side}Pinky1")
                .GetComponentsInChildren<DAZBone>().Select(x => x.transform).ToArray();

            audioSource = BodyRegionMapping.touchZones[$"{side}Palm"].slapAudioSource;

            triggerGO = GameObject.CreatePrimitive(PrimitiveType.Capsule);
            enterPointTF = triggerGO.transform;
            enterPointTF.SetParent(index[0].parent, false);
            enterPointTF.localPosition = new Vector3(sideId * .05f, -.035f, -.01f);
            // triggerGO.transform.localScale = new Vector3(.04f, .04f, .04f);
            enterPointTF.localScale = new Vector3(.03f, .03f, .03f);
            enterPointTF.localRotation = Quaternion.Euler(0f, -sideId * 70f, -sideId * 85f);
            // triggerGO.transform.localRotation = new Quaternion(1f, 1f, -1f, 1f);
            proximityTrigger = triggerGO.GetComponent<CapsuleCollider>();
            // trigger.direction.Print();
            // trigger.direction = 2;
            // trigger.direction.Print();
            proximityTrigger.isTrigger = true;

            triggerGO.GetComponent<Renderer>().enabled = false;
            var hjTrigger = triggerGO.AddComponent<HandJobTrigger>();
            hjTrigger.hand = this;
            foreach (var collider in FillMeUp.atom.GetComponentsInChildren<Collider>())
            {
                Physics.IgnoreCollision(proximityTrigger, collider);
            }

            foreach (var col in FillMeUp.atom.rigidbodies.First(x => x.name == "Gen1")
                         .GetComponentsInChildren<Collider>())
            {
                Physics.IgnoreCollision(proximityTrigger, col, false);
            }
            
            // depthReference = GameObject.CreatePrimitive(PrimitiveType.Sphere);
            // depthReference.transform.localScale = .01f * Vector3.one;
            // depthReference.GetComponent<Collider>().enabled = false;
            // depthReference.transform.SetParent(mid[0].parent, false);
            // depthReference.transform.localPosition = new Vector3(sideId * .055f, -.02f, -.01f);

            // depthReference = GameObject.CreatePrimitive(PrimitiveType.Sphere);
            // depthReference.transform.localScale = .01f * Vector3.one;
            // depthReference.GetComponent<Collider>().enabled = false;
            depthReference = new GameObject();
            depthReference.transform.SetParent(index[0].parent, false);
            depthReference.transform.localPosition = new Vector3(sideId * .065f, -.03f, .01f);

            // depthReferencePinky = GameObject.CreatePrimitive(PrimitiveType.Sphere);
            // depthReferencePinky.transform.localScale = .01f * Vector3.one;
            // depthReferencePinky.GetComponent<Collider>().enabled = false;
            // depthReferencePinky.transform.SetParent(pinky[0].parent, false);
            // depthReferencePinky.transform.localPosition = new Vector3(sideId * .045f, -.02f, -.01f);

            thumbMorphs = new[]
            {
                gameObject.AddComponent<LerpingMorph>().Init(FillMeUp.packageUid +
                                                             $"Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/Hands/Thumb/BL-Finger_{side}Thumb1.vmi"),
                gameObject.AddComponent<LerpingMorph>().Init(FillMeUp.packageUid +
                                                             $"Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/Hands/Thumb/BL-Finger_{side}Thumb2.vmi"),
                gameObject.AddComponent<LerpingMorph>().Init(FillMeUp.packageUid +
                                                             $"Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/Hands/Thumb/BL-Finger_{side}Thumb3.vmi")
            };
            indexMorphs = new[]
            {
                gameObject.AddComponent<LerpingMorph>().Init(FillMeUp.packageUid +
                                                             $"Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/Hands/Index/BL-Finger_{side}Index1.vmi"),
                gameObject.AddComponent<LerpingMorph>().Init(FillMeUp.packageUid +
                                                             $"Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/Hands/Index/BL-Finger_{side}Index2.vmi"),
                gameObject.AddComponent<LerpingMorph>().Init(FillMeUp.packageUid +
                                                             $"Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/Hands/Index/BL-Finger_{side}Index3.vmi")
            };
            midMorphs = new[]
            {
                gameObject.AddComponent<LerpingMorph>().Init(FillMeUp.packageUid +
                                                             $"Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/Hands/Mid/BL-Finger_{side}Mid1.vmi"),
                gameObject.AddComponent<LerpingMorph>().Init(FillMeUp.packageUid +
                                                             $"Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/Hands/Mid/BL-Finger_{side}Mid2.vmi"),
                gameObject.AddComponent<LerpingMorph>().Init(FillMeUp.packageUid +
                                                             $"Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/Hands/Mid/BL-Finger_{side}Mid3.vmi")
            };
            ringMorphs = new[]
            {
                gameObject.AddComponent<LerpingMorph>().Init(FillMeUp.packageUid +
                                                             $"Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/Hands/Ring/BL-Finger_{side}Ring1.vmi"),
                gameObject.AddComponent<LerpingMorph>().Init(FillMeUp.packageUid +
                                                             $"Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/Hands/Ring/BL-Finger_{side}Ring2.vmi"),
                gameObject.AddComponent<LerpingMorph>().Init(FillMeUp.packageUid +
                                                             $"Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/Hands/Ring/BL-Finger_{side}Ring3.vmi")
            };
            pinkyMorphs = new[]
            {
                gameObject.AddComponent<LerpingMorph>().Init(FillMeUp.packageUid +
                                                             $"Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/Hands/Pinky/BL-Finger_{side}Pinky1.vmi"),
                gameObject.AddComponent<LerpingMorph>().Init(FillMeUp.packageUid +
                                                             $"Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/Hands/Pinky/BL-Finger_{side}Pinky2.vmi"),
                gameObject.AddComponent<LerpingMorph>().Init(FillMeUp.packageUid +
                                                             $"Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/Hands/Pinky/BL-Finger_{side}Pinky3.vmi")
            };
            // Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/Hands/Thumb/BL_lThumbOut.vmi
            // Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/Hands/Thumb/BL_rThumbOut.vmi
            thumbOut = gameObject.AddComponent<LerpingMorph>().Init(FillMeUp.packageUid +
                                                                    $"Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/Hands/Thumb/BL_{side}ThumbOut.vmi");
            thumbOut.quicknessIn = 5f;
            // strokeForce = gameObject.AddComponent<Force>().Init("StrokeForce", handRB, () => forward);
            thrustForce.amplitude.mean.SetWithDefault(150f);
            thrustForce.amplitude.delta.SetWithDefault(100f);
            thrustForce.period.sharpness.SetWithDefault(2f);
            
            maleForce.amplitude.mean.SetWithDefault(100f);
            maleForce.amplitude.delta.SetWithDefault(50f);
            
            radialForce = gameObject.AddComponent<Force>().Init(name+":RadialForce", handRB, () => handRB.transform.right);
            radialForce.constant.val = true;
            radialForce.amplitude.delta.SetWithDefault(100f);
            radialForce.amplitude.sharpness.SetWithDefault(2f);

            thrustForce.enabledJ.AddCallback(val =>
            {
                radialForce.SetActive(val && enabled);
            });
            penetrationSoundsVolume.AddCallback(val => audioSource.volume = val);

            sensitivity.SetWithDefault(0f);

            thrustForce.control.presetSystem.Init(false);
            maleForce.control.presetSystem.Init(false);
            // StiffenFingers();

            // GetAngle(thumb[1],1).Print();
            // FillMeUp.atom.GetComponentsInChildren<DAZBone>().ToList().ForEach(x =>
            // {
            //     if (x.name.ToLower().Contains("tongue")) x.name.Print();
            // });
            // FillMeUp.atom.GetComponentsInChildren<DAZBone>().First(x => x.name == "rIndex1");
            return this;
        }

        private void StiffenFingers()
        {

            var cj = pinky[2].GetComponent<ConfigurableJoint>();

            var limit = cj.angularYLimit;
            limit.limit = .001f; //3
            cj.angularYLimit = limit;
            limit = cj.angularZLimit;
            limit.limit = .001f; //3
            cj.angularYLimit = limit;
            // drive = cj.angularXDrive;
            // drive.positionSpring = 
            // drive.positionSpring.Print();
        }

        private void OnDestroy()
        {
            Destroy(triggerGO);
            Destroy(depthReference);
            zeroDepth.Stop();
            zeroSpeed.Stop();
            // for (int i = 0; i < 3; i++)
            // {
            //     indexMorphs[i].morphVal = 0f;
            // }
        }

        public void OnEnable()
        {
            if (penetrator == null) return;
            // name.Print();
            
            // thumbOut.target = .75f - nativeThumbOut.morphValue;
            // lastDepth = depth.val = GetDistance(penetrator.tip);
            // base.OnEnable();
            // if(autoThrust.val) thrustForce.Enable();
            zeroSpeed.Stop();
            zeroDepth.Stop();
            zeroForce.Stop();
            // GetSpeed();
            if (thrustForce.enabledJ.val)
            {
                thrustForce.Enable();
                radialForce.enabled = true;
            }
        }

        public void SetPenetrator(CapsulePenetrator newPenetrator)
        {
            penetrator = newPenetrator;
            penetrator.SetTipAndWith();
            widthToBendScale = .486f / penetrator.width;
            forward = (penetrator.rootTransform.position - penetrator.tip.position).normalized;
            info.val = $"Stroking <b>{penetrator.atom.name}</b>";
            for (int i = 0; i < 3; i++)
            {
                thumbMorphs[i].quicknessIn = indexMorphs[i].quicknessIn = midMorphs[i].quicknessIn =
                    ringMorphs[i].quicknessIn = pinkyMorphs[i].quicknessIn = 0f;
                indexMorphs[i].target = widthToBendScale*.3f + .15f * 1 + indexMorphs[i].morphVal + sideId * .01f * GetAngle(index[i]);
                midMorphs[i].target = widthToBendScale*.35f + .15f * 1 + midMorphs[i].morphVal + sideId * .01f * GetAngle(mid[i]);
                ringMorphs[i].target = widthToBendScale*.35f + .15f * 1 + ringMorphs[i].morphVal + sideId * .01f * GetAngle(ring[i]);
                pinkyMorphs[i].target = widthToBendScale*.3f + .15f * 1 + pinkyMorphs[i].morphVal + sideId * .01f * GetAngle(pinky[i]);
                thumbAngles[i] = GetAngle(thumb[i]);
            }
            if (Vector3.Dot(forward, handRB.transform.forward) > 0f)
            {
                snapTorqueSign = -sideId;
                strokeDirection = -1f;
            }
            else
            {
                snapTorqueSign = sideId;
                strokeDirection = 1f;
            }

            fingersClosed = false;
            thumbOut.target = 2f;
            quicknessIn = 0f;
        }

        public void ResetFingerTargets(float quicknessOut)
        {
            for (int i = 0; i < 3; i++)
            {
                thumbMorphs[i].target = indexMorphs[i].target =
                    midMorphs[i].target = ringMorphs[i].target = pinkyMorphs[i].target = 0f;
                thumbMorphs[i].quicknessOut = indexMorphs[i].quicknessOut = midMorphs[i].quicknessOut =
                    ringMorphs[i].quicknessOut = pinkyMorphs[i].quicknessOut = quicknessOut;
            }
        }

        private float GetAngle(Transform t, int axis = 2)
        {
            if (t.localEulerAngles[axis] > 180f) return t.localEulerAngles[axis] - 360f;
            return t.localEulerAngles[axis];
        }

        public void OnDisable()
        {
            thrustForce.ShutDownImmediate();
            quicknessOut = Random.Range(1f, 6f);
            ResetFingerTargets(quicknessOut);

            thumbOut.target = 0f;
            speedIncrement = 0f;
            info.val = "";
            zeroSpeed = ZeroSpeed().Start();
            zeroDepth = ZeroDepth().Start();
            zeroForce = ZeroForce().Start();
            radialForce.enabled = false;
            penetrator = null;
        }

        private float quicknessIn;
        private float quicknessOut;
        private bool fingersClosed;

        private void FixedUpdate()
        {
            // depth.val = GetDistance(penetrator.tip);
            depth.val = Mathf.Lerp(depth.val, GetDistance(penetrator.tip), 10f*Time.fixedDeltaTime);
            // depth.val.Print();
            
            // GetClosestPenetrator();
            GetSpeed();
            lastDepth = depth.val;
            // quicknessIn = Mathf.Max(quicknessIn, Mathf.Abs(speed.val * 10f));
            quicknessIn = 4f;
            if (Mathf.Abs(speed.val) > .1f && !audioSource.isPlaying)
            {
                audioSource.volume = 6f*Mathf.Abs(speed.val) * penetrationSoundsVolume.val;
                // audioSource.volume.Print();
                FillMeUp.squishLibrary.Play(audioSource);
            }

            for (int i = 0; i < 3; i++)
            {
                if (thumbMorphs[i].enabled) thumbMorphs[i].quicknessIn = quicknessIn;
                if (indexMorphs[i].enabled) indexMorphs[i].quicknessIn = quicknessIn;
                if (midMorphs[i].enabled) midMorphs[i].quicknessIn = quicknessIn;
                if (ringMorphs[i].enabled) ringMorphs[i].quicknessIn = quicknessIn;
                if (pinkyMorphs[i].enabled) pinkyMorphs[i].quicknessIn = quicknessIn;
            }

            var rootPosition = penetrator.rootTransform.position;
            forward = (rootPosition - penetrator.tip.position).normalized;
            up = Vector3.Cross(forward, (rootPosition - handRB.position)).normalized;
            right = Vector3.Cross(forward, up);
            if (!fingersClosed)
            {
                if (magnetic.val) ApplyForce(true);
                if (!indexMorphs[0].enabled)
                {
                    var scale = widthToBendScale * widthToBendScale;
                    fingersClosed = true;
                    thumbOut.target = 0f;
                    thumbMorphs[0].target = scale*.18f - thumbMorphs[0].morphVal - sideId * .01f * thumbAngles[0];
                    thumbMorphs[1].target = scale*.2f + thumbMorphs[1].morphVal - sideId * .01f * thumbAngles[1];
                    thumbMorphs[2].target = scale*.4f - thumbMorphs[2].morphVal + sideId * .01f * thumbAngles[2];
                }
            }
            else if (magnetic.val) ApplyForce(false);

            if(sensitivity.val > 0f) ReadMyLips.Stimulate(50f * speed.val * sensitivity.val, doStim: true, doPlease: true);
            // radialForce.amplitude.current.Print();
            // target = closest.width - closest.width * 10f * (distance.val - .03f);
            // if(name == "lHand") $"{strokeForce.flip} {other.strokeForce.flip}".Print();
        }

        public float GetDistance(Transform point)
        {
            var dist = strokeDirection * Vector3.Dot(point.position - depthReference.transform.position,
                depthReference.transform.forward);
            if (dist < 0f) dist = 0f;
            return dist;
            // return Mathf.Abs(Vector3.Dot(point.position - depthReference.transform.position,
            //     depthReference.transform.forward));
        }

        private void GetSpeed()
        {
            // speed.val = Mathf.Lerp(speed.val, (lastDistance - distance.val)/Time.deltaTime, 5f*Time.deltaTime);
            speed.val += 10f * (depth.val - lastDepth - speed.val * Time.fixedDeltaTime);
            // speed.val.Print();
        }

        private IEnumerator ZeroSpeed()
        {
            var wait = new WaitForFixedUpdate();
            while (Mathf.Abs(speed.val) > .001f)
            {
                speed.val = Mathf.Lerp(speed.val, 0f, 10f * Time.fixedDeltaTime);
                yield return wait;
            }
            speed.val = 0f;
        }

        private IEnumerator ZeroDepth()
        {
            var wait = new WaitForFixedUpdate();
            while (Mathf.Abs(depth.val) > .001f)
            {
                depth.val = Mathf.Lerp(depth.val, 0f, 10f * Time.fixedDeltaTime);
                yield return wait;
            }

            depth.val = lastDepth = 0f;
        }

        private IEnumerator ZeroForce()
        {
            if (!magnetic.val) yield break;
            var wait = new WaitForFixedUpdate();
            while (snapForce.sqrMagnitude > .001f)
            {
                snapForce = Vector3.Lerp(snapForce, Vector3.zero, 2f * Time.fixedDeltaTime);
                snapTorque = Vector3.Lerp(snapTorque, Vector3.zero, Time.fixedDeltaTime * 2f);
                handRB.AddForce(snapForce, ForceMode.Force);
                handRB.AddTorque(snapTorque, ForceMode.Force);
                yield return wait;
            }
            snapForce = Vector3.zero;
        }

        public IEnumerator Reset()
        {
            enabled = false;
            yield return new WaitForFixedUpdate();
            if(!enabled)
            {
                foreach (var lerpingMorph in indexMorphs)
                {
                    lerpingMorph.Reset();
                }

                foreach (var lerpingMorph in midMorphs)
                {
                    lerpingMorph.Reset();
                }

                foreach (var lerpingMorph in ringMorphs)
                {
                    lerpingMorph.Reset();
                }

                foreach (var lerpingMorph in pinkyMorphs)
                {
                    lerpingMorph.Reset();
                }

                foreach (var lerpingMorph in thumbMorphs)
                {
                    lerpingMorph.Reset();
                }
                zeroForce.Stop();
                snapForce = snapTorque = Vector3.zero;
            }
        }
        
        private Vector3 up;
        private Vector3 right;
        private Vector3 snapTorque;
        private float snapTorqueSign;

        private void ApplyForce(bool moveIn)
        {
            if (moveIn)
            {
                snapForce = Vector3.Lerp(snapForce, (forward - right) * 100f, Time.fixedDeltaTime * 3f);
                snapTorque = Vector3.Lerp(snapTorque,
                    snapTorqueSign * sideId * 200f * Vector3.Cross(forward, handRB.transform.forward),
                    Time.fixedDeltaTime * 2f);
            }
            else
            {
                snapForce = Vector3.Lerp(snapForce, (forward - .5f * right) * 100f, Time.fixedDeltaTime);
                // snapTorque = Vector3.Lerp(snapTorque, snapTorqueSign*sideId*100f*Vector3.Cro
                snapTorque = snapTorqueSign * sideId * 200f * Vector3.Cross(forward, handRB.transform.forward);
            }

            handRB.AddForce(snapForce, ForceMode.Force);
            handRB.AddTorque(snapTorque, ForceMode.Force);
        }

        public override void CreateSettingsUI()
        {
            sensitivity.CreateUI(UIElements, true);
            penetrationSoundsVolume.CreateUI(UIElements, true);
        }

        private static UIDynamicTabBar sideTabbar;

        public void CreateHandJobUI()
        {
            FillMeUp.singleton.ClearUI();
            UIElements.Clear();
            var button = FillMeUp.singleton.CreateButton("Return");
            button.buttonColor = new Color(0.55f, 0.90f, 1f);
            button.button.onClick.AddListener(
                () =>
                {
                    // FillMeUp.singleton.RemoveUIElements(UIElements);
                    FillMeUp.singleton.ClearUI();
                    FillMeUp.singleton.CreateUI();
                    FillMeUp.singleton.settingsTabbar.SelectTab(1);
                    FillMeUp.hands[sideTabbar.id].thrustForce.control.UIOpen = false;
                });
            UIElements.Add(button);
            FillMeUp.singleton.SetupButton("Configure Hand Job Sync", true, () => thrustForce.sync.CreateUI(CreateHandJobUI), UIElements);
            FillMeUp.singleton.SetupButton("Paste to other Hand", false, PasteToOtherHand, UIElements);
            sideTabbar = UIManager.CreateTabBar(new [] { "lHand", "rHand"},
                SelectHandJobSide);
            UIElements.Add(sideTabbar);
            sideTabbar.SelectTab(0);
            // strokeForce.control.CreateUI(FillMeUp.singleton);
        }

        private static void SelectHandJobSide(int i)
        {
            FillMeUp.hands[sideTabbar.lastId].thrustForce.control.RemoveUI(FillMeUp.singleton);
            FillMeUp.hands[sideTabbar.lastId].thrustForce.control.UIOpen = false;
            FillMeUp.hands[i].thrustForce.control.CreateUI(FillMeUp.singleton);
            FillMeUp.hands[i].thrustForce.control.UIOpen = true;
        }

        private static void PasteToOtherHand()
        {
            
        }
        
        // public override void CreateForcesUI()
        // {
        //     thrustForce.enabledJ.CreateUI(UIElements);
        //     maleForce.enabledJ.CreateUI(UIElements);
        //     magnetic.CreateUI(UIElements);
        //     FillMeUp.singleton.SetupButton("Configure Thrust", true, () => CreateForceUINewPage(thrustForce), UIElements);
        //     FillMeUp.singleton.SetupButton("Configure Male Thrust", true, () => CreateForceUINewPage(maleForce), UIElements);
        //     // FillMeUp.singleton.SetupButton("Configure Magnet", true, magnet.CreateUINewPage, UIElements);
        // }
        
        public override JSONClass Store(string subScenePrefix, bool storeTriggers = true)
        {
            JSONClass jc = base.Store(subScenePrefix, storeTriggers);
            return jc;
        }

        public override void Load(JSONClass jc, string subScenePrefix)
        {
            if(jc.HasKey(name))
            {
                JSONClass tc = jc[name].AsObject;
                base.Load(jc, subScenePrefix);
            }
        }
    }
}