using System;
using System.Linq;
using System.Security;
using UnityEngine;
using UnityEngine.Serialization;

namespace CheesyFX
{
    public class HandJobTrigger : MonoBehaviour
    {
        protected int collisions;
        public Hand hand;
        protected Penetrator penetrator;
        
        public void OnTriggerEnter(Collider col)
        {
            if(col.isTrigger || !hand.magnetic.val) return;
            if (FillMeUp.penetratorByCollider.TryGetValue(col, out penetrator))
            {
                if(!(penetrator is CapsulePenetrator)) return;
                if (penetrator != hand.penetrator)
                {
                    // if (hand.penetrator == null || hand.depth.val > hand.GetDistance(penetrator.tip))
                    // {
                    //     hand.penetrator = (CapsulePenetrator)penetrator;
                    //     collisions = 0;
                    //     hand.OnEnable();
                    //     // penetrator.tipCollider.Print();
                    // }
                    hand.SetPenetrator((CapsulePenetrator)penetrator);
                    collisions = 0;
                } 
                collisions++;
                if(!hand.enabled) hand.enabled = true;
            }
        }

        public void OnTriggerExit(Collider col)
        {
            // if(!HandJob.penetrators.Select(x => x.collider).Contains(other)) return;
            // handJob.penetrator.colliders.Contains(other).Print();
            // "OnTriggerExit".Print();
            if (col.isTrigger || hand.penetrator == null || !hand.penetrator.colliders.Contains(col)) return;
            collisions--;
            if (collisions == 0)
            {
                Reset();
                // hand.markedForDisable = true;
            }

        }

        public void Reset()
        {
            collisions = 0;
            hand.penetrator = null;
            hand.enabled = false;
        }
    }
}