using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Serialization;

namespace CheesyFX
{
    public class Penetrator : MonoBehaviour
    {
        public int type;
        public Transform tip;
        public Rigidbody root;
        public Transform rootTransform;
        public Collider tipCollider;
        public List<Collider> colliders = new List<Collider>();
        public Atom atom;
        public float scale;
        public float width;
        public ScaleChangeReceiver scaleChangeReceiver;
        public Func<Vector3> forward;
        public bool isPenetrating;

        public Penetrator Init(Collider collider)
        {
            tipCollider = collider;
            atom = collider.GetAtom();
            tip = new GameObject().transform;
            tip.SetParent(this.tipCollider.transform, false);
            enabled = false;
            scaleChangeReceiver = atom.scaleChangeReceivers[0];
            scale = scaleChangeReceiver.scale;
            rootTransform = tipCollider.transform;
            if (rootTransform.parent != null)
            {
                forward = () => (tipCollider.transform.position - tipCollider.transform.parent.position).normalized;
                rootTransform = rootTransform.parent;
                if (rootTransform.parent != null)
                {
                    rootTransform = rootTransform.parent;
                    if (rootTransform.parent != null)
                    {
                        rootTransform = rootTransform.parent;
                    }
                }
                // rootTransform.GetComponent<Rigidbody>().Print();
            }
            else
            {
                forward = () => rootTransform.forward;
            }
            // tip.Draw();
            return this;
        }

        // public virtual void Update()
        // {
        // }
    }
}